/*
 *  UltimateIRCd - an Internet Relay Chat Daemon, src/cio_init.c
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/authors/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: cio_init.c,v 1.3 2002/10/19 00:58:03 shadowmaster Exp $
 *
 */

#include <windows.h>
#include "Cio.h"
#include "CioFunc.h"
#include "common.h"

//
//  FUNCTION: Cio_Init(void)
//
//  PURPOSE: Initializes window data and registers window class and other stuff
//
BOOL
Cio_Init (HINSTANCE hInstance)
{
  WNDCLASS wc;

  // Fill in window class structure with parameters that describe
  // the main window.
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = (WNDPROC) Cio_WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 4;
  wc.hInstance = hInstance;
  wc.hIcon = NULL;
  wc.hCursor = LoadCursor (NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_BTNFACE);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = CIOCLASS;

  if (!RegisterClass (&wc))
    return FALSE;

  return TRUE;
}
