/*
 *  UltimateIRCd - an Internet Relay Chat Daemon, src/res_skipname.c
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/authors/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: res_skipname.c,v 1.3 2002/10/19 00:58:04 shadowmaster Exp $
 *
 */

#include <sys/types.h>
#include <stdio.h>
#include "nameser.h"
#include "common.h"

/*
 * Skip over a compressed domain name. Return the size or -1.
 */
dn_skipname (comp_dn, eom)
     u_char *comp_dn, *eom;
{
  register u_char *cp;
  register int n;

  cp = comp_dn;
  while (cp < eom && (n = *cp++))
    {
      /*
       * check for indirection
       */
      switch (n & INDIR_MASK)
	{
	case 0:		/* normal case, n == len */
	  cp += n;
	  continue;
	default:		/* illegal type */
	  return (-1);
	case INDIR_MASK:	/* indirection */
	  cp++;
	}
      break;
    }
  return (cp - comp_dn);
}
